svn commit: r193905 - projects/stress2/misc

Peter Holm pho at FreeBSD.org
Wed Jun 10 12:04:04 UTC 2009


Author: pho
Date: Wed Jun 10 12:03:55 2009
New Revision: 193905
URL: http://svn.freebsd.org/changeset/base/193905

Log:
  Added two nullfs regression tests

Added:
  projects/stress2/misc/nullfs4.sh   (contents, props changed)
  projects/stress2/misc/nullfs5.sh   (contents, props changed)

Added: projects/stress2/misc/nullfs4.sh
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ projects/stress2/misc/nullfs4.sh	Wed Jun 10 12:03:55 2009	(r193905)
@@ -0,0 +1,52 @@
+#!/bin/sh
+
+#
+# Copyright (c) 2009 Peter Holm <pho at FreeBSD.org>
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD$
+#
+
+# Test scenario by Anatoli Klassen <dev 26th net>
+
+# kern/94269: [nullfs] procfs shows wrong data if executable is running from
+# nullfs
+
+[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1
+
+. ../default.cfg
+
+mount | grep -q /proc || mount -t procfs procfs /proc
+mount -t nullfs /bin $mntpoint
+
+r1=`/bin/ls -l /proc/curproc/file`
+r2=`$mntpoint/ls -l /proc/curproc/file | sed "s#$mntpoint#/bin#"`
+if [ "$r1" != "$r2" ]; then
+	echo "/bin/ls -l /proc/curproc/file"
+	echo $r1
+	echo "$mntpoint/ls -l /proc/curproc/file"
+	echo $r2
+fi
+
+umount $mntpoint

Added: projects/stress2/misc/nullfs5.sh
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ projects/stress2/misc/nullfs5.sh	Wed Jun 10 12:03:55 2009	(r193905)
@@ -0,0 +1,73 @@
+#!/bin/sh
+
+#
+# Copyright (c) 2009 Peter Holm <pho at FreeBSD.org>
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD$
+#
+
+# Composit test: nullfs2.sh + kinfo.sh
+
+# Kernel page fault with the following non-sleepable locks held from
+# nullfs/null_vnops.c:531
+
+[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1
+
+. ../default.cfg
+
+odir=`pwd`
+cd /tmp
+sed '1,/^EOF/d;s/60/600/' < $odir/kinfo.sh > kinfo.c
+cc -o kinfo -Wall -g kinfo.c -lutil
+rm -f kinfo.c
+cd $odir
+
+mount | grep -q procfs || mount -t procfs procfs /procfs
+
+for j in `jot 5`; do
+	/tmp/kinfo &
+done
+
+[ -d mp1 ] || mkdir mp1
+
+mp=`pwd`/mp1
+mount | grep -q $mp && umount -f $mp
+
+mount -t nullfs `dirname $RUNDIR` $mp
+
+export RUNDIR=`pwd`/mp1/stressX
+export runRUNTIME=10m
+(cd ..; ./run.sh marcus.cfg) 
+
+umount $mp 2>&1 | grep -v busy
+
+mount | grep -q $mp && umount -f $mp
+
+rm -rf mp1
+
+for j in `jot 5`; do
+	wait
+done
+rm -f /tmp/kinfo


More information about the svn-src-projects mailing list